unit u_main;

{$mode objfpc}{$H+}
// Collapse all procedures:  alt shift 1

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type { TFrmMain }

  TFrmMain = class(TForm)
    ButtClearLinGraph: TButton;
    ButtProcess: TButton;
    ButtOpen: TButton;
    ButtWriteParameters: TButton;
    ButtReadParameters: TButton;
    ButtRefresh: TButton;
    CbxForceEnd: TCheckBox;
    CbxShowNumerals: TCheckBox;
    CbxTrace11: TCheckBox;
    CbxTrace7: TCheckBox;
    CbxWideScreen: TCheckBox;
    CbxTrace9: TCheckBox;
    CbxTrace1: TCheckBox;
    CbxTrace10: TCheckBox;
    CbxTrace2: TCheckBox;
    CbxTrace3: TCheckBox;
    CbxTrace4: TCheckBox;
    CbxTrace5: TCheckBox;
    CbxTrace6: TCheckBox;
    CbxTrace8: TCheckBox;
    Label10: TLabel;
    Label11: TLabel;
    Speed: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    LinGraph: TPaintBox;
    Memo: TMemo;
    OpenDialog: TOpenDialog;
    TbxPrecessionSpeed: TEdit;
    TbxAPeakRim_1: TEdit;
    TbxDrivePulseWidth: TEdit;
    TbxEllipseShortAxis_mm: TEdit;
    TbxOffset_10: TEdit;
    TbxOffset_11: TEdit;
    TbxOffset_2: TEdit;
    TbxOffset_3: TEdit;
    TbxOffset_4: TEdit;
    TbxOffset_5: TEdit;
    TbxOffset_6: TEdit;
    TbxOffset_7: TEdit;
    TbxOffset_8: TEdit;
    TbxOffset_9: TEdit;
    TbxScale_10: TEdit;
    TbxScale_11: TEdit;
    TbxScale_2: TEdit;
    TbxScale_3: TEdit;
    TbxScale_4: TEdit;
    TbxScale_5: TEdit;
    TbxScale_6: TEdit;
    TbxScale_7: TEdit;
    TbxScale_8: TEdit;
    TbxScale_9: TEdit;
    TbxStatus: TEdit;
    TbxTPassRim_2: TEdit;
    TbxCompression: TEdit;
    TbxAPeakRim_2: TEdit;
    TbxPath: TEdit;
    TbxProcessing: TEdit;
    TbxTPassCenter: TEdit;
    TbxTimeStamp: TEdit;
    TbxHour: TEdit;
    TbxPrecessionAngle_Degrees: TEdit;
    TbxTotalLines: TEdit;
    TbxOS: TEdit;
    TbxTest: TEdit;
    TbxAPeakCenter: TEdit;
    TbxTPassRim_1: TEdit;
    Timer: TTimer;
    procedure ButtClearLinGraphClick(Sender: TObject);
    procedure ButtOpenClick(Sender: TObject);
    procedure ButtWriteParametersClick(Sender: TObject);
    procedure ButtReadParametersClick(Sender: TObject);
    procedure ButtProcessClick(Sender: TObject);
    procedure ButtRefreshClick(Sender: TObject);
    procedure ButtSTOPClick(Sender: TObject);
    procedure CbxShowNumeralsChange(Sender: TObject);
    procedure CbxForceEndChange(Sender: TObject);
    procedure CbxTrace10Change(Sender: TObject);
    procedure CbxTrace1Change(Sender: TObject);
    procedure CbxTrace2Change(Sender: TObject);
    procedure CbxTrace3Change(Sender: TObject);
    procedure CbxTrace4Change(Sender: TObject);
    procedure CbxTrace5Change(Sender: TObject);
    procedure CbxTrace6Change(Sender: TObject);
    procedure CbxTrace7Change(Sender: TObject);
    procedure CbxTrace8Change(Sender: TObject);
    procedure CbxTrace9Change(Sender: TObject);
    procedure CbxWideScreenChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

const VERSIONSTRING = 'Analyse_2212: 2023-01-10';

var
  FrmMain: TFrmMain;
  Hour: word;
  avTPassCenter, avApeakCenter,
    avTPassRim_1, avAPeakRim_1, avTPassRim_2, avAPeakRim_2,
    avEllipseShortAxis_mm,
    avPrecessionAngle_Degrees,
    avDrivePulseWidth,
    PrecessionSpeed, avPrecessionSpeed,
    PrevavPrecessionAngle_Degrees: real;

procedure AddToLog (LogString: ansistring);

implementation
{$R *.lfm}

uses strutils, u_display;

type t_State = (tIdle = 0, tStartProcessing, tProcessing, tStopped);

var
  ParameterFileName: string;
  Naverage: integer;
  TimerState: t_State = tIdle;
  Title, LogStr, Path, Slash: shortstring;
  FileCount, LineCount, i, Increment, nSelected: longint;
  Processing, ForceEnd, ShowNumerals: boolean;
  Scale: real;
  Status: word;
  TPassCenter, TPassCenterDiff, TPassRim_1, TPassRim_2: real;
  AmplitudeFromRim_mm, EllipseShortAxis_mm, Angle,
  PrecessionAngle_Degrees: real;
  APeakCenter, APeakRim_1, APeakRim_2: byte;
  DrivePulseWidth: byte;
  Compression: integer; // number of lines from logfile to be averaged

function Int64UntilComma (var InpStr: shortstring): int64; forward;

function FIval (InpStr: string): longint;
var Temp: longint;
begin
  val (InpStr, Temp);
  FIval:= Temp;
end;

function FRval (InpStr: string): double;
var Temp: real;
begin
  val (InpStr, Temp);
  FRval:= Temp;
end;

procedure AddToLog (LogString: ansistring);
var LogFile: text;
  const LogFileName= 'test.log';
begin
  assign (LogFile, LogFileName);
  {$i-}
  if FileExists (LogFileName) then append(LogFile) else rewrite (LogFile);
  writeln (LogFile, LogString);
  close (LogFile);
  {$i+}
end;

procedure ReadLogFile (InFileName: shortstring);
const
  avFactor = 0.3;  // for precessionspeed
var
  InFile: text;
  InputLine: shortstring;
  TimeStamp: string;
begin
  if Processing then exit;
  Processing:= true;
  with FrmMain do
  begin
    CbxForceEnd.checked:= false;
    system.assign (InFile, InFileName);
    reset (InFile);
    LineCount:= 0;
    while not (eof (InFile) or ForceEnd) do
    begin
      Readln (InFile, InputLine);
      while InputLine[22] = '*' do
      begin
        Readln (InFile, InputLine); // skip comment lines
      end;
      TimeStamp:= midstr (InputLine, 1, 21);
      TbxTimeStamp.text:= Timestamp;
      Hour:= fIval(midstr (TimeStamp,10,2));
      InputLine:= midstr (InputLine, 24, length (InputLine)); // strip timestamp
      Status:=                  Int64UntilComma (InputLine);
      TPassCenter:=             Int64UntilComma (InputLine);
      TPassCenterDiff:=         Int64UntilComma (InputLine);
      APeakCenter:=             Int64UntilComma (InputLine);
      TPassRim_1:=              Int64UntilComma (InputLine);
      APeakRim_1:=              Int64UntilComma (InputLine);
      TPassRim_2:=              Int64UntilComma (InputLine);
      APeakRim_2:=              Int64UntilComma (InputLine);
      AmplitudeFromRim_mm:=     Int64UntilComma (InputLine);
      EllipseShortAxis_mm:=     Int64UntilComma (InputLine);
      PrecessionAngle_Degrees:= Int64UntilComma (InputLine);

      DrivePulseWidth:= 0;
      if (Status and $0100) = $0100 then DrivePulseWidth += 10; // Minimal DriveWidth
      if (Status and $0200) = $0100 then DrivePulseWidth += 20; // Maximal DriveWidth
      if (Status and $1000) = $1000 then DrivePulseWidth += 40; // Has Reset Myself
      TbxStatus.text:= format ('%6d', [Status]);

      Application.ProcessMessages;

      // We use a block average over Compression-value of data lines
      avTPasscenter += TPasscenter;
      avAPeakCenter += APeakCenter;
      avTPassRim_1 += TPassRim_1;
      avAPeakRim_1 += APeakRim_1;
      avTPassRim_2 += TPassRim_2;
      avAPeakRim_2 += APeakRim_2;
      avEllipseShortAxis_mm += EllipseShortAxis_mm;
      avPrecessionAngle_Degrees += PrecessionAngle_Degrees;
      avDrivePulseWidth += DrivePulseWidth;
      inc (Naverage);
      if Naverage >= Compression then
      begin
        nAverage:= 0;
        avTPassCenter /= Compression;
        avAPeakCenter /= Compression;
        avTPassRim_1 /= Compression;
        avAPeakRim_1 /= Compression;
        avTPassRim_2 /= Compression;
        avAPeakRim_2 /= Compression;
        avEllipseShortAxis_mm /= Compression;
        avPrecessionAngle_Degrees /= Compression;
        avDrivePulseWidth /= Compression;
        // calc derivative
        PrecessionSpeed:= avPrecessionAngle_Degrees - PrevavPrecessionAngle_Degrees;
        PrevavPrecessionAngle_Degrees:= avPrecessionAngle_Degrees;
        // and apply leaking bucket averaging
        avPrecessionSpeed:= avPrecessionSpeed * (1-avFactor) + PrecessionSpeed * avFactor;
        LinGraph_Update;
        if ShowNumerals then
        begin
       	  TbxHour.text:= format('%2d', [Hour]);
    	  TbxTPassCenter.text:= format('%6f', [avTPassCenter]);
          TbxAPeakCenter.text:= format('%3f', [avAPeakCenter]);
    	  TbxTPassRim_1.text:= format('%6f', [avTPassRim_1]);
     	  TbxAPeakRim_1.text:= format('%3f', [avAPeakRim_1]);
          TbxTPassRim_2.text:= format('%6f', [avTPassRim_2]);
     	  TbxAPeakRim_2.text:= format('%3f', [avAPeakRim_2]);
   	  TbxEllipseShortAxis_mm.text:= format('%6.2f', [avEllipseShortAxis_mm]);
   	  TbxPrecessionAngle_Degrees.text:= format('%5.1f', [avPrecessionAngle_Degrees]);
          TbxPrecessionSpeed.text:= format('%5.1f', [PrecessionSpeed]);
          TbxDrivePulseWidth.text:= format('%5.1f', [avDrivePulseWidth]);
        end;
        // clear the averages
        avTPasscenter:= 0;
        avAPeakCenter:= 0;
        avTPassRim_1:= 0;
        avAPeakRim_1:= 0;
        avTPassRim_2:= 0;
        avAPeakRim_2:= 0;
        avEllipseShortAxis_mm:= 0;
        avPrecessionAngle_Degrees:= 0;
        avDrivePulseWidth:= 0;
      end;
    end;
  end;
  system.close (InFile);
  dec (LineCount);
  FrmMain.TbxTotalLines.text:= format ('%10d', [LineCount]);
  Processing:= false;
end;

procedure ReadParametersFromTextBoxes;
begin
  with FrmMain do
  begin
    Scale_2:=  fRval (TbxScale_2.text);
    Scale_3:=  fRval (TbxScale_3.text);
    Scale_4:=  fRval (TbxScale_4.text);
    Scale_5:=  fRval (TbxScale_5.text);
    Scale_6:=  fRval (TbxScale_6.text);
    Scale_7:=  fRval (TbxScale_7.text);
    Scale_8:=  fRval (TbxScale_8.text);
    Scale_9:=  fRval (TbxScale_9.text);
    Scale_10:= fRval (TbxScale_10.text);
    Scale_11:= fRval (TbxScale_11.text);
    Offset_2:=  fIval (TbxOffset_2.text);
    Offset_3:=  fIval (TbxOffset_3.text);
    Offset_4:=  fIval (TbxOffset_4.text);
    Offset_5:=  fIval (TbxOffset_5.text);
    Offset_6:=  fIval (TbxOffset_6.text);
    Offset_7:=  fIval (TbxOffset_7.text);
    Offset_8:=  fIval (TbxOffset_8.text);
    Offset_9:=  fIval (TbxOffset_9.text);
    Offset_10:= fIval (TbxOffset_10.text);
    Offset_11:= fIval (TbxOffset_11.text);
  end;
end;

procedure WriteParametersToTextBoxes;
begin
  with FrmMain do
  begin
    TbxScale_2.text:= format('%5.2f', [Scale_2]);
    TbxScale_3.text:= format('%5.2f', [Scale_3]);
    TbxScale_4.text:= format('%5.2f', [Scale_4]);
    TbxScale_5.text:= format('%5.2f', [Scale_5]);
    TbxScale_6.text:= format('%5.2f', [Scale_6]);
    TbxScale_7.text:= format('%5.2f', [Scale_7]);
    TbxScale_8.text:= format('%5.2f', [Scale_8]);
    TbxScale_9.text:= format('%5.2f', [Scale_9]);
    TbxScale_10.text:= format('%5.2f', [Scale_10]);
    TbxScale_11.text:= format('%5.2f', [Scale_11]);
    TbxOffset_2.text:= format('%6d', [Offset_2]);
    TbxOffset_3.text:= format('%6d', [Offset_3]);
    TbxOffset_4.text:= format('%6d', [Offset_4]);
    TbxOffset_5.text:= format('%6d', [Offset_5]);
    TbxOffset_6.text:= format('%6d', [Offset_6]);
    TbxOffset_7.text:= format('%6d', [Offset_7]);
    TbxOffset_8.text:= format('%6d', [Offset_8]);
    TbxOffset_9.text:= format('%6d', [Offset_9]);
    TbxOffset_10.text:= format('%6d', [Offset_10]);
    TbxOffset_11.text:= format('%6d', [Offset_11]);
  end;
end;

procedure WriteParametersToFile;
var
  ParameterFile: text;
begin
  assign (ParameterFile, ParameterFileName);
  rewrite (ParameterFile);
  ReadParametersFromTextBoxes;
  writeln (ParameterFile, Scale_2);
  writeln (ParameterFile, Scale_3);
  writeln (ParameterFile, Scale_4);
  writeln (ParameterFile, Scale_5);
  writeln (ParameterFile, Scale_6);
  writeln (ParameterFile, Scale_7);
  writeln (ParameterFile, Scale_8);
  writeln (ParameterFile, Scale_9);
  writeln (ParameterFile, Scale_10);
  writeln (ParameterFile, Scale_11);
  writeln (ParameterFile, Offset_2);
  writeln (ParameterFile, Offset_3);
  writeln (ParameterFile, Offset_4);
  writeln (ParameterFile, Offset_5);
  writeln (ParameterFile, Offset_6);
  writeln (ParameterFile, Offset_7);
  writeln (ParameterFile, Offset_8);
  writeln (ParameterFile, Offset_9);
  writeln (ParameterFile, Offset_10);
  writeln (ParameterFile, Offset_11); ;
  Close (ParameterFile);
end;

procedure ReadParametersFromFile;
var
  ParameterFile: text;
begin
  if not FileExists (ParameterFileName) then exit;
  assign (ParameterFile, ParameterFileName);
  reset (ParameterFile);
  readln (ParameterFile, Scale_2);
  readln (ParameterFile, Scale_3);
  readln (ParameterFile, Scale_4);
  readln (ParameterFile, Scale_5);
  readln (ParameterFile, Scale_6);
  readln (ParameterFile, Scale_7);
  readln (ParameterFile, Scale_8);
  readln (ParameterFile, Scale_9);
  readln (ParameterFile, Scale_10);
  readln (ParameterFile, Scale_11);
  readln (ParameterFile, Offset_2);
  readln (ParameterFile, Offset_3);
  readln (ParameterFile, Offset_4);
  readln (ParameterFile, Offset_5);
  readln (ParameterFile, Offset_6);
  readln (ParameterFile, Offset_7);
  readln (ParameterFile, Offset_8);
  readln (ParameterFile, Offset_9);
  readln (ParameterFile, Offset_10);
  readln (ParameterFile, Offset_11);
  Close (ParameterFile);
  WriteParametersToTextBoxes;
end;

procedure TFrmMain.ButtRefreshClick (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxForceEndChange(Sender: TObject);
begin
  ForceEnd:= CbxForceEnd.Checked;
end;

procedure TFrmMain.CbxTrace1Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace2Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace3Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace4Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace5Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace6Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace7Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace8Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxTrace9Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.CbxWideScreenChange (Sender: TObject);
begin
  if CbxWideScreen.Checked then
  begin
    NPoints:= 1800;
    Divs:= 18;
    Frmmain.width:= 1820;
  end
  else
  begin
    NPoints:= 1000;
    Divs:= 10;
    FrmMain.width:= 1020;
  end;
end;

procedure TFrmMain.CbxTrace10Change (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.ButtClearLinGraphClick (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  LinGraph_Clear;
  LinGraph_Init;
  LinGraph_Refresh;
end;

procedure TFrmMain.ButtSTOPClick(Sender: TObject);
begin
  //Halt;
end;

procedure TFrmMain.CbxShowNumeralsChange (Sender: TObject);
begin
  ShowNumerals:= CbxShowNumerals.Checked;
end;

function FI64val (InpStr: string): int64;
var Temp: int64;
begin
  val (InpStr, Temp);
  FI64val:= Temp;
end;

function Int64UntilComma (var InpStr: shortstring): int64;
// returns the remaining part of InpStr
var
  Temp, TempInpStr: shortstring;
  p:integer;
begin
  Temp := '';
  TempInpStr:= InpStr;
  for p:= 1 to length (TempInpStr) do
  begin
    if midstr(TempInpStr, p, 1)<>',' then
    begin
      Temp:= Temp + midstr (TempInpStr, p, 1);
      InpStr:= midstr (InpStr, 2, length(InpStr));
    end
    else break;
  end;
  InpStr:= midstr (Inpstr, 2, length (InpStr));
  Int64UntilComma:= FI64val (Temp);
end;

function StripPath (Path: string): string;
var N: Integer;
begin
for N := Length (Path) downto 1 do
  if (Path[N]= '\') or (Path[N] = '/') Then
  begin
    StripPath:= Midstr(Path, N+1, Length (Path));
    Exit;
  end;
If N <= 1 Then StripPath:= Path;
end;

procedure SplitPath (OrgPath: string; var Path, FileName: string);
var N: Integer;
begin
for N := Length (OrgPath) downto 1 do
  if (OrgPath[N] = '\') or (OrgPath[N] = '/') Then
  begin
    FileName := Midstr (OrgPath, N + 1, Length (OrgPath));
    Path := Midstr (OrgPath, 1, N);
    Exit;
  end;
If N <= 1 Then begin Path := ''; FileName := OrgPath; end;
end;

function ReadLastPath: string;
var
  LastPath: text;
  Path: string;
begin
  Path := Slash;
  assign (LastPath, 'LastPath');
  if FileExists ('LastPath') then
  begin
    reset (LastPath);
    readln (LastPath, Path);
    close (LastPath);
  end;
  ReadLastPath := Path;
end;

procedure WriteLastPath (Path: string);
var LastPath: text;
begin
  assign (LastPath, 'LastPath');
  rewrite (LastPath);
  writeln (LastPath, Path);
  close (LastPath);
end;

procedure TFrmMain.ButtOpenClick (Sender: TObject);
var Counter: integer;
    Path, FileName: string;
begin
  OpenDialog.InitialDir:= ReadLastPath;
  OpenDialog.Filter:= 'Log|*.log';
  OpenDialog.FilterIndex:= 1;
  if OpenDialog.Execute then
  begin
    Memo.clear;
    nSelected := OpenDialog.Files.Count-1;
    for Counter:= 0 to nSelected do
    begin
      SplitPath (OpenDialog.Files.Strings[Counter], Path, FileName);
      Memo.Lines[Counter] := FileName;
      TbxPath.Text := Path;
      WriteLastPath (Path);
    end;
    ButtProcess.enabled:= true;
 end;
end;

procedure TFrmMain.ButtWriteParametersClick (Sender: TObject);
begin
  WriteParametersToFile;
end;

procedure TFrmMain.ButtReadParametersClick (Sender: TObject);
begin
  ReadParametersFromFile;
end;

procedure TFrmMain.TimerTimer (Sender: TObject);
begin
  case TimerState of
  tIdle:
  begin
    TbxProcessing.text:= 'Idle';
  end;

  tStartProcessing:
  begin
    ReadLogfile (TbxPath.Text + Memo.Lines[FileCount]);
    TbxProcessing.text:= 'Processing';
    TimerState := tProcessing;
  end;

  tProcessing:
  begin
    if Processing = false then  // prev file finished
    begin
      if FileCount < nSelected then
      begin
      	inc (FileCount);
      	TimerState := tStartProcessing;
      end
      else TimerState := tStopped;
    end;
  end;

  tStopped:
  begin
    TimerState := tIdle;
    ButtOpen.Enabled := true;
    ButtProcess.Enabled := true;
    TbxProcessing.text:= 'Stopped';
  end;
end;
end;

procedure TFrmMain.ButtProcessClick (Sender: TObject);
begin
  ReadParametersFromTextBoxes;
  ButtOpen.Enabled := false;
  ButtProcess.Enabled := false;
  FileCount := 0;
  Compression:= fival (TbxCompression.Text);
  TimerState := tStartProcessing;
end;

procedure TFrmMain.FormCreate (Sender: TObject);
var OStype: string;
begin
  Title:= VERSIONSTRING;
  Caption:= Title + ' (no file)';
    {$IFDEF Linux}
    OSType:= 'Linux';
    Slash := '/';
  {$ELSE}
    {$IFDEF WINDOWS}
      OSType:= 'Windows';
      Slash := '\';
     {$ENDIF}
  {$ENDIF}
  TbxOS.text:= OSType;
  ParameterFileName:= 'Parameters.txt';
  ReadParametersFromFile;
  CbxWideScreen.checked:= true;
end;

procedure TFrmMain.FormDestroy (Sender: TObject);
begin
  WriteParametersToFile;
end;


end.

